unit Winhdl;
interface
uses
 Tasks,
 SysUtils,WinTypes, ToolHelp, WinProcs, Forms;

var
 oldTasks,oldWin,
 NumWin            : Integer;
 WIN_NAM,TASK_NAME,
 TASK_PATH         : array [0 .. max_Butt] of String[150];
 TASK_HDL          : array [0 .. max_Butt] of THandle;
 WIN_HDL           : array [0 .. max_Butt] of HWnd;

procedure myEnum(task : THandle;numTask : Integer);
procedure GetWinHdl(bis,stat :Integer);
procedure ClearArray;
procedure GetTasks(Sender: TObject);
procedure SortHdl;

implementation
var
 ENUM          : Boolean;
 z_wnd,nxt_wnd : Integer;
 PrTASK        : THandle;

procedure GetTasks(Sender: TObject);
var
 pTask : pTaskEntry;
 Task  : bool;
 PStr  : array [0..144] of Char;
 Str   : String[13];
 i,
 newTasks : Word;

BEGIN
 GetMem(pTask, SizeOf(TTaskEntry));
 pTask^.dwSize := SizeOf(TTaskEntry);
 newTasks      := GetNumTasks;

 if (newTasks <> oldTasks) AND        {nichts gendert?}
    (NOT ENUM)             THEN begin
  ClearArray;
  PrTask := GetWindowTask(Application.Handle);{das bin ich selber}
  Task   := TaskFirst(pTask);
  i      := 1;                        {die 0 ist reserviert}

  while Task do begin                 {take a walk ...}
   ENUM:= True;                       {ob es hilft ??}
   Str := StrPas(pTask^.szModule);    {Name}
   GetModuleFileName(pTask^.hModule,PStr,145);{Pfad}

   if PrTask = pTask^.hTask then begin
    TASK_HDL[0]  := pTask^.hTask;     {index 0 bleibt stets unsichtbar}
    TASK_PATH[0] := StrPas(PStr);     {d.h. eigenes Programm}
    TASK_NAME[0] := Str;
   end
   else begin
    TASK_HDL[i]  := pTask^.hTask;
    TASK_PATH[i] := StrPas(PStr);
    TASK_NAME[i] := Str;
    inc(i);
   end;
   Task := TaskNext(pTask);           {der Nchste bitte ...}
  end;
  FreeMem(pTask, SizeOf(TTaskEntry)); {ach ja, Ressourcen}
  oldTasks := newTasks;
  SortHdl;                            {shell-sort, Ordnung}
  GetWinHdl(newTasks,1);              {echter Versuch}
  oldWin   := NumWin;
   TasksF1.BuildButton(NumWin);       {Bau auf, bau auf ...}
 end
 else begin
  FreeMem(pTask, SizeOf(TTaskEntry)); {ach ja, Ressourcen}
  GetWinHdl(newTasks,0);              {nur check !}
  if (NumWin <> oldWin) then          {keine nderung?}
   inc(oldTasks);
 end;
END;

procedure SortHdl ;                   {etwas Ordnung in der Leiste}
var                                   {shell-Sort Algorithmus     }
 bis,i,j,k : longint;                 {nutzt zwar nicht viel, aber ...}
 h         : THandle;
 s         : String[150];

BEGIN
 bis := oldTasks - 1;
 k   := bis shr 1;

 while k > 0 do begin                 {0 ist mein eigenes}
  for i := 1 To bis - k do begin      {sortiere ab index 1}
   j := i;
   while (j > 0) And (TASK_HDL[j] > TASK_HDL[j + k]) do begin
    h   := TASK_HDL[j];
    TASK_HDL[j]     := TASK_HDL[j + k];
    TASK_HDL[j + k] := h;

    s := TASK_NAME[j];
    TASK_NAME[j]    := TASK_NAME[j + k];
    TASK_NAME[j + k]:= s;

    s := TASK_PATH[j];
    TASK_PATH[j]    := TASK_PATH[j + k];
    TASK_PATH[j + k]:= s;
    dec(j,k);
   end;
  end;
  k := k shr 1;
 end;
END;

procedure GetWinHdl(bis, stat :Integer);
var
 i:Integer;                           {stat = 0: nur Tockentest}

BEGIN
 NumWin := 0;    z_wnd := 0;
 ENUM   := True;

 for i := 0 to bis do begin
   nxt_wnd := 0;                      {Fenster pro Task}
   myEnum(TASK_HDL[i],stat);
  end;
END;

procedure ClearArray;
var
 i  :Integer;

BEGIN
for i:= 0 to oldTasks do begin
   TASK_HDL[i]  := 0;                 {sicherheitshalber}
   TASK_PATH[i] := '';
   TASK_NAME[i] := '';
   WIN_NAM[i]   := '';
   WIN_HDL[i]   := 0;
 end;
END;

function EnumTaskWinProc(hnd : HWnd; lparam : LongInt):Bool;export;
var
 len,que,
 par     : Integer;
 task    : THandle;
 WText,CN: array [0..81] of Char;
 OwnWin,
 ParWin  : HWnd;

BEGIN
 Result := True;
 que := 1;  par := 0; err := False;

 task   := GetWindowTask(hnd);
 GetWindowText(hnd,WText,80);
 len    := GetWindowTextLength(hnd);

 if vis then  begin                   {nur sichtbare?}
   if isWindowVisible(hnd) then
        que := 1
   else que := 0;
 end;

 OwnWin := GetWindow(hnd,GW_OWNER);
 ParWin := GetParent(hnd);
 GetClassName(hnd,CN,81);

 if (ParWin = 0)         AND          {nur bergeordnete}
    (OwnWin = ParWin)    THEN         {Fenster zulassen}
  par := 1;

 if (StrPas(CN) = 'THintWindow') OR   {delphi hint - Fenster}
    (StrPas(CN) = 'GWStipClass') THEN {zB: auch GWS ...}
  par := 0;

 if
    (par = 1)              AND        {valid ?}
    (len > 0)              AND        {ohne Text?}
    (que = 1)                         {fr visible}

 then begin
  if lparam = 1 then begin            {bei check nichts ndern}
   WIN_NAM[z_wnd] := StrPas(WText);
   WIN_HDL[z_wnd] := hnd;
  end;

  NumWin := z_wnd;                    {akt.Fensterzahl}
  if z_wnd < max_Butt then            {keine berschreitung !}
   inc   (z_wnd);
  inc (nxt_wnd);                      {Fenster eines Owner}

  if nxt_wnd > 10 then
   err := True;                       {manche Programme haben}
                                      {mehr Fenster}
                                      {als Programmzeilen}

  if (task <> PrTask) AND
     (NOT err)        AND
     (NOT vis)        THEN
       Result := True                 {fr ENUMeration}
  else Result := False;
 end;
END;

procedure myEnum(task : THandle;numTask : Integer);
BEGIN
 ENUM := EnumTaskWindows(task,@EnumTaskWinProc,numTask);
END;
END.
